Index: /trunk/SophyaExt/JThreadsC++/JTCSrc/LICENSE
===================================================================
--- /trunk/SophyaExt/JThreadsC++/JTCSrc/LICENSE	(revision 1023)
+++ /trunk/SophyaExt/JThreadsC++/JTCSrc/LICENSE	(revision 1023)
@@ -0,0 +1,281 @@
+ROYALTY-FREE PUBLIC LICENSE AGREEMENT FOR JTHREADS/C++ SOFTWARE
+
+IMPORTANT-READ CAREFULLY: This Object-Oriented Concepts, Inc.
+Royalty-Free Public License Agreement for ORBacus Software ("License")
+is a legal agreement between you, the Licensee, (either an individual
+or a single entity) and Object-Oriented Concepts, Inc. ("OOC") for
+non-commercially using, copying, distributing and modifying the
+Software and any work derived from the Software, as defined
+hereinbelow.  Any commercial use is subject to a different license.
+
+By using, modifying or distributing the Software or any work derived
+from the Software, Licensee indicates acceptance of this License, and
+agrees to be bound by all its terms and conditions for using, copying,
+distributing or modifying the Software and works derived from the
+Software.
+
+No rights are granted to the Software except as expressly set forth
+herein.  Nothing other than this License grants Licensee permission to
+use, copy, distribute or modify the Software or any work derived from
+the Software.  Licensee may not use, copy, distribute or modify the
+Software or any work derived from the Software except as expressly
+provided under this License.  If Licensee does not accept the terms
+and conditions of this License, do not use, copy, distribute or modify
+the Software.
+
+In consideration for Licensee's forbearance of commercial use of the
+Software, OOC grants Licensee non-exclusive, royalty-free rights as
+expressly provided herein.
+
+DEFINITIONS.
+
+The "Software" is the JThreads/C++ software, including, but not
+limited to, the JThreads/C++ Libraries, demo programs, associated
+media and printed materials, and any included "on-line" documentation.
+
+A "work derived from the Software" is any derivative work, as defined
+in 17 U.S.C. paragraph 101, which is derived from the Software, for
+example, a program which is linked with or otherwise incorporates the
+JThreads/C++ Libraries, or a translation, improvement, enhancement,
+extension or other modification of the Software.
+
+To "use" means to execute (i.e. run) the Software.
+
+To "copy" means to create one or more copies as defined in 17 U.S.C.
+paragraph 101.
+
+To "distribute" means to broadcast, publish, transfer, post, upload,
+download or otherwise disseminate in any medium to any third party.
+
+To "modify" means to create a work derived from the Software.
+
+A "commercial use" is:
+
+(1) the use of the Software or any work derived from the Software in
+connection with, for or in aid of the generation of revenue, such as
+in the conduct of Licensee's daily business operations; or
+
+(2) any copying, distribution or modification of the Software or any
+work derived from the Software to any party where payment or other
+consideration is made in connection with such copying, distribution or
+modification, whether directly (as in payment for a copy of the
+Software) or indirectly (including but not limited to payment for some
+good or service related to the Software, or payment for some product
+or service that includes a copy of the Software "without
+charge"). However, the following actions which involve payment do not
+in and of themselves constitute a commercial use:
+
+(a) posting the Software on a public access information storage and
+retrieval service for which a fee is received for retrieving
+information (such as an on-line service), provided that the fee is not
+content-dependent.  Such fees which are not content dependent include,
+but are not limited to, fees which are based solely on the storage
+capacity required to store the information, and fees which are based
+solely on the time required to transfer the information from/to the
+public access information storage and retrieval service; and
+
+(b) distributing the Software on a CD-ROM, provided that the Software
+is reproduced entirely and verbatim on such CD-ROM, and provided
+further that all information on such CD-ROM may be distributed in a
+manner which does not constitute a commercial use.
+
+GRANT OF LICENSE.
+
+LICENSE TO USE.
+Licensee may use the Software provided that such use does not
+constitute a commercial use.
+
+LICENSE TO COPY AND DISTRIBUTE.
+Licensee may copy and distribute literal (i.e., verbatim) copies of
+the Software as Licensee receives it throughout the world, in any
+medium, provided that Licensee distributes an unmodified,
+easily-readable copy of this License with the Software, and provided
+further that such distribution does not constitute a commercial use.
+
+LICENSE TO CREATE WORKS DERIVED FROM THE SOFTWARE.
+Licensee may create works derived from the Software, provided that any
+such work derived from the Software carries prominent notices stating
+both the manner in which Licensee has created a work derived from the
+Software (for example, notices stating that the work derived from the
+Software is linked with or otherwise incorporates the JThreads/C++
+Libraries, or notices stating that the work derived from the Software
+is an enhancement to the Software which Licensee has created) and the
+date any such work derived from the Software was created.
+
+LICENSE TO COPY AND DISTRIBUTE WORKS DERIVED FROM THE SOFTWARE.
+Licensee may copy and distribute works derived from the Software
+throughout the world, provided that Licensee distributes an
+unmodified, easily-readable copy of this License with such works
+derived from the Software, and provided further that such distribution
+does not constitute a commercial use.  Licensee must cause any work
+derived from the Software that Licensee distributes to be licensed as
+a whole and at no charge to all third parties under the terms of this
+License.
+
+Any work derived from the Software must be accompanied by the complete
+corresponding machine-readable source code of such work derived from
+the Software, delivered on a medium customarily used for software
+interchange.  The source code for the work derived from the Software
+means the preferred form of the work derived from the Software for
+making modifications to it.  For an executable work derived from the
+Software, complete source code means all of the source code for all
+modules of the work derived from the Software, all associated
+interface definition files and all scripts used to control compilation
+and installation of all or any part of the work derived from the
+Software.  However, the source code delivered need not include
+anything that is normally distributed, in either source code or binary
+(object-code) form, with major components (including but not limited
+to compilers, linkers and kernels) of the operating system on which
+the executable work derived from the Software runs, unless that
+component itself accompanies the executable code of the work derived
+from the Software;
+
+Furthermore, if the executable code or object code of the work derived
+from the Software may be copied from a designated place, and if the
+source code of the work derived from the Software may be copied from
+the same place, then the work derived from the Software shall be
+construed as accompanied by the complete corresponding
+machine-readable source code of such work derived from the Software,
+even though third parties are not compelled to copy the source code
+along with the executable code or object code.
+
+If the work derived from the Software normally reads commands
+interactively when run, Licensee must cause the work derived from the
+Software, at each time it commences operation, to print or display an
+announcement including an appropriate copyright notice and either a
+notice consisting of the verbatim warranty and liability provisions of
+this License, or a notice that Licensee, and not OOC provides a
+warranty.  Such notice must also state that users may distribute the
+Software and/or the work derived from the Software only under the
+conditions of this License, and must further state how to view the
+copy of this License included with the work derived from the Software.
+
+Licensee may not impose any further restrictions on the exercise of
+the rights granted herein by any recipient of any work derived from
+the Software.
+
+RESTRICTIONS.
+
+Licensee acknowledges that the Software is protected by copyright laws
+and international copyright treaties, as well as other intellectual
+property laws and treaties.  The Software is licensed, not sold.  All
+title and copyrights in and to the Software, including but not limited
+to any images, photographs, databases, animations, video, text and
+"applets" incorporated into the Software, the accompanying printed
+materials, and any copies of the Software, are owned exclusively by
+OOC.
+
+Licensee may not sublicense, assign or transfer this License, the
+Software or any work derived from the Software except as permitted by
+this License.
+
+If Licensee distributes any written or printed material at all with
+the Software or any work derived from the Software, such material must
+include either (a) a written copy of this License, or (b) a prominent
+written indication that the Software or work derived from the Software
+is covered by this License, and also written instructions for printing
+and/or displaying the copy of this License which is provided on the
+distribution medium.
+
+If using, copying, distributing and/or modifying the Software is
+restricted in certain countries for any reason, OOC may in the future
+add an explicit geographical distribution limitation excluding those
+countries, so that using, copying, distributing and/or modifying is
+permitted only in or among countries not thus excluded.  In such case,
+this License incorporates the limitation as if written in the body of
+this License.
+
+LICENSE TO WORKS DERIVED FROM THE SOFTWARE.
+
+Licensee hereby grants to OOC a non-exclusive, non-transferable,
+royalty-free right to use, copy, distribute and modify, with the right
+to sublicense at any tier, any and all works derived from the Software
+that Licensee creates, provided such works derived from the Software
+are distributed to OOC by Licensee, and further provided that, if such
+works derived from the Software comprise a program which is linked
+with or otherwise incorporates the JThreads/C++ Libraries, such works
+derived from the Software would constitute works derived from the
+Software independent of a program which is linked with or otherwise
+incorporates the JThreads/C++ Libraries, for example, a "bug fix" of
+the Software.
+
+LIMITED WARRANTY.
+
+NO WARRANTIES.
+OOC EXPRESSLY DISCLAIMS ANY WARRANTY FOR THE SOFTWARE.  THE SOFTWARE
+IS PROVIDED TO LICENSEE "AS IS," WITHOUT WARRANTY OF ANY KIND, EITHER
+EXPRESS OR IMPLIED, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
+WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+NONINFRINGEMENT OF THIRD PARTY RIGHTS.  THE ENTIRE RISK AS TO THE USE,
+QUALITY AND PERFORMANCE OF THE SOFTWARE IS WITH LICENSEE.  SHOULD THE
+SOFTWARE PROVE DEFECTIVE, LICENSEE ASSUMES THE COST OF ALL NECESSARY
+SERVICING, REPAIR OR CORRECTION.
+
+NO LIABILITY FOR DAMAGES.
+IN NO EVENT WILL OOC, OR ANY OTHER PARTY WHO MAY COPY, DISTRIBUTE OR
+MODIFY THE SOFTWARE AS PERMITTED HEREIN, BE LIABLE FOR ANY GENERAL,
+DIRECT, INDIRECT, INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES
+WHATSOEVER (INCLUDING, WITHOUT LIMITATION, DAMAGES FOR LOSS OF
+BUSINESS PROFITS, BUSINESS INTERRUPTION, INACCURATE INFORMATION, LOSS
+OF INFORMATION, OR ANY OTHER PECUNIARY LOSS) ARISING OUT OF THE USE OR
+INABILITY TO USE THE SOFTWARE, EVEN IF OOC OR SUCH OTHER PARTY HAS
+BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
+
+U.S. GOVERNMENT RESTRICTED RIGHTS.
+
+The Software is provided with RESTRICTED RIGHTS.  Use, duplication or
+disclosure by the Government is subject to restrictions as set forth
+in subparagraph (c)(1)(ii) of The Rights in Technical Data and
+Computer Software clause at DFARS 252.227-7013 or subparagraphs (c)(1)
+and (2) of the Commercial Computer Software-Restricted Rights 48
+C.F.R. paragraph 52.227-19, as applicable.  Manufacturer is
+Object-Oriented Concepts, Inc./44 Manning Road/Billerica, MA 01821
+
+TERMINATION.
+
+Any violation or any attempt to violate any of the terms and
+conditions of this License will automatically terminate Licensee's
+rights under this License.  Licensee further agrees upon such
+termination to cease any and all using, copying, distributing and
+modifying of the Software and any work derived from the Software, and
+further to destroy any and all of Licensee's copies of the Software
+and any work derived from the Software.
+
+However, parties who have received copies of the Software or copies of
+any work derived from the Software, or rights, from Licensee under
+this License will not have their licenses terminated so long as such
+parties remain in full compliance with this License.
+
+LICENSE SCOPE AND MODIFICATION.
+
+This License sets forth the entire agreement between Licensee and OOC
+and supersedes all prior agreements and understandings between the
+parties relating to the subject matter hereof.  None of the terms of
+this License may be waived or modified except as expressly agreed in
+writing by both Licensee and OOC.
+
+SEVERABILITY.
+
+Should any provision of this License be declared void or
+unenforceable, the validity of the remaining provisions shall not be
+affected thereby.
+
+GOVERNING LAWS.
+
+This License is governed by the laws of the Commonwealth of
+Massachusetts, U.S.A., and shall be interpreted in accordance with and
+governed by the laws thereof.
+
+Licensee hereby waives any and all right to assert a defense based on
+jurisdiction and venue for any action stemming from this License
+brought in U.S. District Court for the District of Massachusetts.
+
+
+
+Should Licensee have any questions concerning this License, or if
+Licensee desires to contact Object-Oriented Concepts, Inc. for any
+reason, please contact Object-Oriented Concepts, Inc. at:
+
+                Object-Oriented Concepts, Inc.
+                44 Manning Road
+                Billerica, MA 01821
Index: /trunk/SophyaExt/JThreadsC++/JTCSrc/Makefile
===================================================================
--- /trunk/SophyaExt/JThreadsC++/JTCSrc/Makefile	(revision 1022)
+++ /trunk/SophyaExt/JThreadsC++/JTCSrc/Makefile	(revision 1023)
@@ -63,4 +63,5 @@
 	if (test ! -d $(JTCBASEREP)/Include/JTC) then mkdir $(JTCBASEREP)/Include/JTC ; fi
 	cp JTC/*.h $(JTCBASEREP)/Include/JTC
+	chmod a+r $(JTCBASEREP)/Include/JTC/*
 	if (test ! -d $(JTCBASEREP)/$(SYSCOMPNOM)) then mkdir $(JTCBASEREP)/$(SYSCOMPNOM) ; fi
 	if (test ! -d $(JTCBASEREP)/$(SYSCOMPNOM)/Libs)  then mkdir $(JTCBASEREP)/$(SYSCOMPNOM)/Libs ; fi
@@ -68,4 +69,6 @@
 	cp Objs/libJTC.a $(JTCBASEREP)/$(SYSCOMPNOM)/Libs
 	cp Objs/libJTC.so $(JTCBASEREP)/$(SYSCOMPNOM)/ShLibs
+	chmod a+r $(JTCBASEREP)/$(SYSCOMPNOM)/Libs/libJTC.a
+	chmod a+r $(JTCBASEREP)/$(SYSCOMPNOM)/ShLibs/libJTC.so
 
 $(OBJ)Cond.o : Cond.cpp
Index: /trunk/SophyaExt/JThreadsC++/README
===================================================================
--- /trunk/SophyaExt/JThreadsC++/README	(revision 1023)
+++ /trunk/SophyaExt/JThreadsC++/README	(revision 1023)
@@ -0,0 +1,63 @@
+The JThreads/C++ is a C++ class library implementing
+multi-threading with Java look & feel, developped by:
+
+                Object-Oriented Concepts, Inc.
+                44 Manning Road
+                Billerica, MA 01821
+               ( http://www.ooc.com/ )
+
+(See the licence agreement in JTCSrc/LICENCE)
+
+The source code here corresponds to version 1.0.10 and
+has been downloaded from the OOC web site (May 2000).
+A specific makefile (Makefile) has been written, with 
+support for DEC/Compaq TruUnix64, cxx, Linux and g++, 
+as well as SGI IRIX-64 (and SGI-CC) and KCC.
+
+Note: The static library which is build (libJTC.a) 
+by the present version of the Makefile may not 
+work for all compilers.
+
+The config file (JTC/Config.h) has been modified to 
+provide multiple platform / multiple compiler support
+using switches (#ifdef) in a single file.
+
+***********************************************
+***** Building and installing the library *****
+***********************************************
+
+1) Select the compiler through the environment variable 
+EROSCXX
+2) Build the libray (make in JTCSrc)
+3) Define the path for installation through the 
+JTCBASEREP environment variable
+4) Install (make install in JTCSrc)
+5) Try to build and test the example programs
+(make in Examples/) - The LD_LIBRARY_PATH should
+contain $JTCBASEREP/`uname`-$EROSCXX/ShLibs
+6) The use of GNU make is mandatory
+
+The example below shows the installation and building
+for a Dec/Compaq machine, with the native cxx compiler,
+using c-shell commands. (uname = OSF1)
+
+Cmd> setenv EROSCXX cxx
+Cmd> setenv JTCBASEREP /usr/local/
+Cmd> cd JTCSrc
+# GNU make program should be used
+Cmd> make
+# Create the Objs directory for .o .a .so files
+Cmd> make install
+# Creates /usr/local/Include/JTC for include files
+#         /usr/local/OSF1-cxx/Libs    (libJTC.a)
+#         /usr/local/OSF1-cxx/ShLibs  (libJTC.so)
+# Copies .h files and .a .so libraries
+
+Build and run the example programs :
+Cmd> cd ../Examples
+Cmd> make 
+Cmd> setenv LD_LIBRARY_PATH ${LD_LIBRARY_PATH}:${JTCBASEREP}/OSF1-cxx/ShLibs
+Cmd> ./diner or ./hello ...
+
+
+
Index: /trunk/SophyaExt/JThreadsC++/README_OOC
===================================================================
--- /trunk/SophyaExt/JThreadsC++/README_OOC	(revision 1023)
+++ /trunk/SophyaExt/JThreadsC++/README_OOC	(revision 1023)
@@ -0,0 +1,9 @@
+For installation instructions, please read the files INSTALL (for
+Unix-based operating system) and INSTALL.WINDOWS (for Windows 95/98
+and Windows NT).
+
+This distribution contains the following package(s):
+
+JThreads/C++ version 1.0.10 in the directory "jtc". See the
+jtc/README* files for more information. For licensing information, see
+the file jtc/LICENSE.