Index: /trunk/SophyaPI/PIext/basexecut.cc
===================================================================
--- /trunk/SophyaPI/PIext/basexecut.cc	(revision 1034)
+++ /trunk/SophyaPI/PIext/basexecut.cc	(revision 1035)
@@ -237,7 +237,7 @@
   mObjMgr->AddObj(h, tokens[0]);
   }
-else if (kw == "newprof") {
+else if (kw == "newprof" || kw == "newprofe") {
   if (tokens.size() < 4)
-    { cout << "Usage: newprof name xmin xmax nbin [ymin ymax]" << endl; return(0); }
+    { cout << "Usage: newprof[e] name xmin xmax nbin [ymin ymax]" << endl; return(0); }
   int nbx;
   float xmin, xmax, ymin = 1., ymax = -1.;
@@ -249,4 +249,5 @@
   xmin = atof(tokens[1].c_str());   xmax = atof(tokens[2].c_str());
   HProf* h = new HProf(xmin, xmax, nbx, ymin, ymax);
+  if(kw == "newprofe") h->SetErrOpt(false);
   mObjMgr->AddObj(h, tokens[0]);
   }
@@ -815,22 +816,28 @@
 kw = "newh1d";
 usage = "Creates a 1D histogramm \n Usage: newh1d name xmin xmax nbin";
-usage += "\n  Related commands: newh2d  newprof newnt  newgfd ";  
+usage += "\n  Related commands: newh2d  newprof[e] newnt  newgfd ";  
 mpiac->RegisterCommand(kw, usage, this, "Objects");
 kw = "newh2d";
 usage = "Creates a 2D histogramm \n Usage: newh2d name xmin xmax nbinx ymin ymax nbiny";
-usage += "\n  Related commands: newh1d  newprof newnt  newgfd ";  
+usage += "\n  Related commands: newh1d  newprof[e] newnt  newgfd ";  
 mpiac->RegisterCommand(kw, usage, this, "Objects");
 kw = "newprof";
 usage = "Creates a profile histogramm \n Usage: newprof name xmin xmax nbin [ymin ymax]";
-usage += "\n  Related commands: newh1d  newh2d newnt newgfd ";  
+usage += "\n  Errors represent the data spread in the X bin ";  
+usage += "\n  Related commands: newh1d  newh2d newprofe newnt newgfd ";  
+mpiac->RegisterCommand(kw, usage, this, "Objects");
+kw = "newprofe";
+usage = "Creates a profile histogramm \n Usage: newprofe name xmin xmax nbin [ymin ymax]";
+usage += "\n  Errors represent the error on the data mean in the X bin ";  
+usage += "\n  Related commands: newh1d  newh2d newprof newnt newgfd ";  
 mpiac->RegisterCommand(kw, usage, this, "Objects");
 kw = "newnt";
 usage = "Creates a ntuple \n Usage: newnt name v1 v2 v3 .. vn";
 usage += "\n        newnt name nvar";  
-usage += "\n  Related commands: newh1d  newh2d newprof newgfd ";  
+usage += "\n  Related commands: newh1d  newh2d newprof[e] newgfd ";  
 mpiac->RegisterCommand(kw, usage, this, "Objects");
 kw = "newgfd";
 usage = "Creates GeneralFit Data object \n Usage: newgfd nvar nalloc [errx(0/1)]";
-usage += "\n  Related commands: newh1d  newh2d  newprof newnt ";  
+usage += "\n  Related commands: newh1d  newh2d  newprof[e] newnt ";  
 mpiac->RegisterCommand(kw, usage, this, "Objects");
 kw = "newvec";
Index: /trunk/SophyaPI/PIext/pawexecut.cc
===================================================================
--- /trunk/SophyaPI/PIext/pawexecut.cc	(revision 1034)
+++ /trunk/SophyaPI/PIext/pawexecut.cc	(revision 1035)
@@ -26,4 +26,6 @@
 
 /* Reza + cmv  13/10/99 */
+
+uint_4 PAWExecutor::autoc_counter_ = 0;
 
 /* methode */
@@ -173,5 +175,5 @@
 if(tokens.size() < 1) {
   cout
-  <<"Usage: n/plot nameobj.x_exp [cut] [w_exp] [loop] [gratt]"<<endl
+  <<"Usage: n/plot nameobj.x_exp [cut] [w_exp] [loop] [gratt] [nomh1]"<<endl
   <<"       n/plot nameobj.y_exp%x_exp [cut] [loop] [gratt]"<<endl
   <<"       n/plot nameobj.z_exp%y_exp%x_exp [cut] [loop] [gratt]"<<endl
@@ -181,5 +183,6 @@
 string nameobj,expx,expy,expz;
 int nvar = decodepawstring(tokens[0],nameobj,expx,expy,expz);
-string expcut = "1"; string expwt = "1."; string loop = ""; string dopt = "";
+string expcut = "1"; string expwt = "1."; string loop = "";
+string dopt = ""; string nameproj="";
 if(tokens.size()>=2) expcut = tokens[1]; if(expcut=="!") expcut="1";
 
@@ -190,10 +193,16 @@
   cout<<"PAWExecutor::n_plot Error: bad coding "<<tokens[0]<<endl;
 } else if(nvar==1) { // c'est un plot 1D
-  if(tokens.size()>=3) expwt = tokens[2]; if(expwt=="!") expwt="1.";
-  if(tokens.size()>=4) loop  = tokens[3]; if(loop=="!") loop="";
-  if(tokens.size()>=5) dopt  = tokens[4];
-  string nameproj = "/autoc/paw_n_plot1D";
-  AnyDataObj* mobj = omg.GetObj(nameproj);
-  //  if(mobj!=NULL) omg.DelObj(nameproj);  $CHECK$ Reza 12/12/99 - clean auto 
+  if(tokens.size()>=3) expwt    = tokens[2]; if(expwt=="!") expwt="1.";
+  if(tokens.size()>=4) loop     = tokens[3]; if(loop=="!") loop="";
+  if(tokens.size()>=5) dopt     = tokens[4]; if(dopt=="!") dopt="";
+  if(tokens.size()>=6) nameproj = tokens[5];
+  if(nameproj.length()<=0 || nameproj=="!") {
+    nameproj = "/autoc/paw_n_plot1D_";
+    AnyDataObj* mobj = omg.GetObj(nameproj);
+    if(mobj!=NULL) {
+      char buff[16]; autoc_counter_++; sprintf(buff,"%d",autoc_counter_);
+      nameproj += buff;
+    }
+  }
   srvo->ProjectH1(nameobj,expx,expwt,expcut,nameproj,dopt,loop);
 } else if(nvar==2) { // c'est un plot 2D
Index: /trunk/SophyaPI/PIext/pawexecut.h
===================================================================
--- /trunk/SophyaPI/PIext/pawexecut.h	(revision 1034)
+++ /trunk/SophyaPI/PIext/pawexecut.h	(revision 1035)
@@ -32,4 +32,5 @@
                       ,string& xexp,string& yexp,string& zexp);
   PIStdImgApp* mApp;
+  static uint_4 autoc_counter_;
 };
 