Index: /trunk/SophyaPI/PIext/Makefile
===================================================================
--- /trunk/SophyaPI/PIext/Makefile	(revision 1037)
+++ /trunk/SophyaPI/PIext/Makefile	(revision 1038)
@@ -28,4 +28,5 @@
  $(INC)piwdgx.h \
  $(INC)piwdggen.h \
+ $(INC)picolist.h \
  $(INC)pimenubarx.h \
  $(INC)pimenubargen.h \
@@ -105,4 +106,5 @@
  $(INC)piwdggen.h \
  $(INC)pimsghandler.h \
+ $(INC)picolist.h \
  $(INC)picmap.h \
  $(INC)picmapx.h \
@@ -177,6 +179,6 @@
  $(INC)rzvect.h \
  $(INC)perrors.h \
- $(EXTINCPATH)FitsIO/fitsio.h \
- $(EXTINCPATH)FitsIO/longnam.h \
+ /exp/planck/ExtLibs/Include/FitsIO/fitsio.h \
+ /exp/planck/ExtLibs/Include/FitsIO/longnam.h \
  $(INC)pisurfdr.h pipodrw.h \
  $(INC)histos2.h \
@@ -199,4 +201,5 @@
  $(INC)piwdggen.h \
  $(INC)pimsghandler.h \
+ $(INC)picolist.h \
  $(INC)picmap.h \
  $(INC)picmapx.h \
@@ -224,4 +227,5 @@
  $(INC)piwdggen.h \
  $(INC)pimsghandler.h \
+ $(INC)picolist.h \
  $(INC)picmap.h \
  $(INC)picmapx.h \
@@ -265,4 +269,5 @@
  $(INC)piwdggen.h \
  $(INC)pimsghandler.h \
+ $(INC)picolist.h \
  $(INC)picmap.h \
  $(INC)picmapx.h \
@@ -309,6 +314,6 @@
  $(INC)piwindowgen.h \
  $(INC)picontainerx.h \
- $(INC)picontainergen.h pipodrw.h servnobjm.h \
- $(INC)pdlmgr.h dlftypes.h
+ $(INC)picontainergen.h pipodrw.h \
+ servnobjm.h $(INC)pdlmgr.h dlftypes.h
 $(OBJ)nomimagadapter.o: nomimagadapter.cc \
  $(INC)machdefs.h nomimagadapter.h \
@@ -323,4 +328,5 @@
  $(INC)piwdggen.h \
  $(INC)pimsghandler.h \
+ $(INC)picolist.h \
  $(INC)picmap.h \
  $(INC)picmapx.h \
@@ -355,4 +361,5 @@
  $(INC)piwdggen.h \
  $(INC)pimsghandler.h \
+ $(INC)picolist.h \
  $(INC)picmap.h \
  $(INC)picmapx.h \
@@ -404,4 +411,5 @@
  $(INC)piwdggen.h \
  $(INC)pimsghandler.h \
+ $(INC)picolist.h \
  $(INC)picmap.h \
  $(INC)picmapx.h \
@@ -448,4 +456,5 @@
  $(INC)piwdggen.h \
  $(INC)pimsghandler.h \
+ $(INC)picolist.h \
  $(INC)picmap.h \
  $(INC)picmapx.h \
@@ -503,4 +512,5 @@
  $(INC)piwdgx.h \
  $(INC)piwdggen.h \
+ $(INC)picolist.h \
  $(INC)pimenubarx.h \
  $(INC)pimenubargen.h \
@@ -543,6 +553,7 @@
  $(INC)piperiodx.h \
  $(INC)periodic.h
-$(OBJ)piacmd.o: piacmd.cc piacmd.h $(INC)machdefs.h \
- dlftypes.h $(INC)pdlmgr.h basexecut.h \
+$(OBJ)piacmd.o: piacmd.cc piacmd.h \
+ $(INC)machdefs.h dlftypes.h \
+ $(INC)pdlmgr.h basexecut.h \
  $(INC)ctimer.h pistdimgapp.h \
  $(INC)pisysdep.h \
@@ -554,4 +565,5 @@
  $(INC)piwdgx.h \
  $(INC)piwdggen.h \
+ $(INC)picolist.h \
  $(INC)pimenubarx.h \
  $(INC)pimenubargen.h \
@@ -640,6 +652,6 @@
  $(INC)hisprof.h \
  $(INC)objfitter.h piafitting.h \
- $(INC)pdlmgr.h dlftypes.h piacmd.h nobjmgr.h \
- pistdimgapp.h $(INC)pisysdep.h \
+ $(INC)pdlmgr.h dlftypes.h piacmd.h \
+ nobjmgr.h pistdimgapp.h $(INC)pisysdep.h \
  $(INC)piapplx.h \
  $(INC)piapplgen.h \
@@ -649,4 +661,5 @@
  $(INC)piwdgx.h \
  $(INC)piwdggen.h \
+ $(INC)picolist.h \
  $(INC)pimenubarx.h \
  $(INC)pimenubargen.h \
@@ -716,4 +729,5 @@
  $(INC)piwdggen.h \
  $(INC)pimsghandler.h \
+ $(INC)picolist.h \
  $(INC)picmap.h \
  $(INC)picmapx.h \
@@ -754,4 +768,5 @@
  $(INC)piwdggen.h \
  $(INC)pimsghandler.h \
+ $(INC)picolist.h \
  $(INC)picmap.h \
  $(INC)picmapx.h \
@@ -792,4 +807,5 @@
  $(INC)piwdggen.h \
  $(INC)pimsghandler.h \
+ $(INC)picolist.h \
  $(INC)picmap.h \
  $(INC)picmapx.h \
@@ -811,4 +827,5 @@
  $(INC)piwdgx.h \
  $(INC)piwdggen.h \
+ $(INC)picolist.h \
  $(INC)pimenubarx.h \
  $(INC)pimenubargen.h \
@@ -857,6 +874,6 @@
  $(INC)nbrandom.h \
  $(INC)srandgen.h
-$(OBJ)piinit.o: piinit.cc $(INC)machdefs.h piinit.h \
- $(INC)sambainit.h \
+$(OBJ)piinit.o: piinit.cc $(INC)machdefs.h \
+ piinit.h $(INC)sambainit.h \
  $(INC)skymapinit.h \
  $(INC)sophyainit.h \
@@ -871,4 +888,5 @@
  $(INC)piwdgx.h \
  $(INC)piwdggen.h \
+ $(INC)picolist.h \
  $(INC)pimenubarx.h \
  $(INC)pimenubargen.h \
@@ -965,4 +983,5 @@
  $(INC)piwdggen.h \
  $(INC)pimsghandler.h \
+ $(INC)picolist.h \
  $(INC)picmap.h \
  $(INC)picmapx.h \
@@ -987,4 +1006,5 @@
  $(INC)piwdggen.h \
  $(INC)pimsghandler.h \
+ $(INC)picolist.h \
  $(INC)picmap.h \
  $(INC)picmapx.h \
@@ -1005,4 +1025,5 @@
  $(INC)piwdggen.h \
  $(INC)pimsghandler.h \
+ $(INC)picolist.h \
  $(INC)picmap.h \
  $(INC)picmapx.h \
@@ -1053,4 +1074,5 @@
  $(INC)piwdgx.h \
  $(INC)piwdggen.h \
+ $(INC)picolist.h \
  $(INC)pimenubarx.h \
  $(INC)pimenubargen.h \
@@ -1122,4 +1144,5 @@
  $(INC)piwdgx.h \
  $(INC)piwdggen.h \
+ $(INC)picolist.h \
  $(INC)pimenubarx.h \
  $(INC)pimenubargen.h \
@@ -1212,4 +1235,5 @@
  $(INC)piwdggen.h \
  $(INC)pimsghandler.h \
+ $(INC)picolist.h \
  $(INC)picmap.h \
  $(INC)picmapx.h \