Index: trunk/SophyaLib/Mgr/Makefile
===================================================================
--- trunk/SophyaLib/Mgr/Makefile	(revision 1040)
+++ trunk/SophyaLib/Mgr/Makefile	(revision 1041)
@@ -27,5 +27,5 @@
 	@echo "  $(DPCDEVREP)/`uname`-$(EROSCXX)" 
 	if [ -d Mgr ] ; then cd Mgr; \
-	./crerep_sophya $(DPCDEVREP) $(EROSCXX); \
+	./crerep_sophya $(DPCDEVREP) `uname`-$(EROSCXX); \
 	./makefileuser.csh; \
 	./mkmflien -copy ; \
Index: trunk/SophyaLib/Mgr/README
===================================================================
--- trunk/SophyaLib/Mgr/README	(revision 1040)
+++ trunk/SophyaLib/Mgr/README	(revision 1041)
@@ -1,21 +1,150 @@
-=================== Module Mgr ==================
-===== Outils de gestion de code EROS/Planck =====
-=================================================
+========================== Mgr Module =========================
+========== Code Management scripts for Planck DPC-L2 ==========
+===============================================================
 
-Mini guide des scripts de gestion du code
-                          Reza 04/99
+List of modules:
+==================
+
+* Mgr/           Scripts for code management and makefiles
+* SysTools/      General architecture support classes
+* TArray/        Template numerical arrays, vectors and matrices
+* SkyMap/        Local and full sky maps
+* SkyT/          Spectral emission and detector frequency response modelling   
+* Samba/         Miscellaneous classes (TOD analysis, Spherical Harmonics, ...)
+* NTools/        Some standard numerical analysis tools 
+* HiStats/       Histogram-ming and data set handling classes
+
+Modules using external library 
+* FitsIOServer/  FITS format file I/O (interface with cfitsio library)
+* LinAlg/        Interface with Lapack linear algebra package
+* IFFTW/         Interface with FFTW package
 
 
-* chk_cvs.csh
---------------
-  Permet de comparer/ updater par rapport a la base CVS
-  Usage chk_cvs.csh [-a] [-all] [-nos] [-u] [r]
-  Exemple : se mettre au dessus de Mgr/
-  Mgr/chk_cvs.csh -u  
-  Update tous les modules   
+* Tests/         Simple test programs
 
-* crerep_peida 
---------------
-  Creation des repertoires   $DEV/BASEREP/Include
+* PMixer/        skymixer and utility main programs
+
+* PI/            GUI class library
+* PIext/         specific GUI objects for SOPHYA classes and piapp framework
+* ProgPI/        interactive analysis tool using SOPHYA, PI and PIext
+
+
+Compilation and software installation:
+======================================
+
+The build procedure for the present version of SOPHYA has been 
+tested on :
+
+Operating system            Compiler
+......................................................................
+Compaq/DEC OSF 4.0           cxx 6.1         (shared-library only)
+Compaq/DEC OSF 4.0           g++ 2.95        (shared-library only)
+SGI                          CC  7.30        (   "    "      "   )
+Linux                        KCC 3.4         (   "    "      "   )
+Linux                        g++ 2.91        (static and shared library)
+Linux                        g++ 2.95        (static and shared library)
+
+
+The environment variables  DPCDEVREP EXTLIBDIR EROSCXX must be defined
+for building and installing the libraries.
+
+$EROSCXX is the name of C++ compiler being used.
+$DPCDEVREP is the path to where the libraries and executables will be put.
+$DPCDEVREP/Include : header files
+The libraries and binaries will be put in subdirectories containing 
+the operating system name and the compiler name: `uname`-$EROSCXX
+For example, on a Linux system, using the GNU compiler:
+
+$DPCDEVREP/Linux-g++/Libs     archive librarires
+$DPCDEVREP/Linux-g++/ShLibs   shared libraries
+$DPCDEVREP/Linux-g++/Exec     binaries
+
+The build procedure expects to find the include files and the libraries 
+for cfitsio in :
+$EXTLIBDIR/Include/FitsIO 
+$EXTLIBDIR/`uname`-$EROSCXX/Libs
+This would translate to Linux-g++ on a Linux system, using g++.
+$EXTLIBDIR/Linux-g++/Libs
+
+Example of c-shell commands to build the libraries:
+The use of GNU make program is mandatory 
+
+# We select our C++ compiler
+csh> setenv EROSCXX g++
+# Setup the build directory
+csh> mkdir /usr/local/Sophya/
+csh> setenv DPCDEVREP /usr/local/Sophya/
+csh> setenv EXTLIBDIR /usr/local/ExtLibs/
+
+# Use the top level makefile in Mgr/ 
+csh> cd $SRC
+csh> cp Mgr/Makefile Makefile
+# Step 1: Create the directory tree and copy the include files (.h)
+csh> make depend
+# Step 2: Compile the modules without external library reference
+csh> make libs
+# Step 3: Compile the modules WITH  external library reference (optional) 
+csh> make extlibs
+# Step 4: Build libsophya.so
+csh> make slb
+# Step 5: Build libextsophya.so 
+csh> make slbext
+# Step 6: Compile the PI and PIext modules (optional)
+csh> make PI
+# Step 7: Build the corresponding shared library libPI.so (optional)
+csh> make slbpi
+
+
+To compile all modules and build the shared libraries, it is possible to use:
+
+# Step 2,3,6
+csh> make all
+# Step 4,5,7
+csh> make slball
+
+The building of shared libraries on SGI can be also done using the script 
+mkslbsgi.csh in Mgr/
+
+csh> cp Mgr/mkslbsgi.csh .
+csh> mkslbsgi.csh slball
+
+# To compile test programs
+csh> cd Tests
+csh> make arrt ...
+csh> cd ..
+# To compile other programs, for example from the PMixer module
+csh> cd PMixer
+csh> make
+csh> cd ..
+# To build (s)piapp (libPI.so is needed)
+csh> cd ProgPI
+csh> make 
+csh> cd ..
+
+Notes:
+======
+1) We had to build the shared libraries on our SGI system using the 
+script (mkslbsgi.csh). The corresponding CC command was not performing
+correctly when issued by the GNU make program
+2) The top level Makefile should be modified if one wishes to use 
+static libraries, except for g++. The compiler driver has to be 
+invoked for building archive libraries, in order to include 
+template instanciation into the archive.
+
+
+
+Scripts in Mgr/ module :
+========================
+
+* chk_cvs.csh : Compares/updates modules using CVS
+  Usage: chk_cvs.csh [-a] [-all] [-nos] [-u] [r]
+         chk_cvs.csh  -h  for help
+  Example :
+  Cmd> Mgr/chk_cvs.csh -u  
+  Updates all modules 
+
+* crerep_sophya
+  Creates the directory tree structure :
+                             $DEV/BASEREP/Include
                                          /OSF1-cxx/
                                          /OSF1-cxx/Objs
@@ -24,60 +153,44 @@
                                          /OSF1-cxx/Exec/
                                          ....
-  Usage crerep_peida <nom des repertoires> [nom_machine-compilateur]
-  Exemple crerep_peida $DPCDEVREP OSF1-cxx 
-          crerep_peida ~/Work/ Linux-g++
+  Usage: crerep_sophya <nom des repertoires> [nom_machine-compilateur]
+  Example :
+  Cmd> crerep_sophya $DPCDEVREP OSF1-cxx 
+  Cmd> crerep_sophya ~/Work/ Linux-g++
 
-* install_peida
-----------------
-  Script d'installation PEIDA (du soft)
-  depuis le repertoire de developpement vers le repertoire d'install
-  Copie des Include/*.h Libs/*.a ShLibs/*.so Exec/*
+* install_sophya
+  Install SOPHYA libraries/include files from dev directory ($DPCDEVREP)
+  to the install ($DPCBASEREP) directory
+  Copy files Include/*.h Libs/*.a ShLibs/*.so Exec/*
 
-  Usage install_peida <-s repertoire source> <-d repertoire destination>
+  Usage: install_sophya <-s repertoire source> <-d repertoire destination>
                       [-m nom_machine-compilateur]
-  Exemple install_peida -s  ~/Work  /exp/Planck/DPC
+  Example 
+  Cmd> install_peida -s  ~/Work  /exp/Planck/DPC
 
 * mkmf
--------
-  Script de creation des GNUmakefile des differents modules,
-  et le GNUmakefile global, mis au niveau au dessus
-  Pour le makefile global, Makefile.slb est utilise
+  Creates a GNUmakefile in each library module and the global 
+  GNUmakefile at top level
 
-  Les etapes :
-  - mkmflien : Cree des liens symboliques pour tous les .h des modules
-               ds $DEVREP/Include
-  - Creation du GNUmakefile global (pour appeler le make de chaque module)
-  - mkmflib 
-    Creation des GNUmakefile pour chaque module librairie
-    Note : Dans chaque module, un fichier exclude peut contenir 
-    la liste des fichiers (.cc, .c) qui ne doivent pas etre compile,
-    faire partie de la librairie
+  Steps :
+  - mkmflien : Creates symbolic links for all header files in $DPCDEVREP/Include
 
-  - mkmfPI
-    Creation des GNUmakefile pour les modules PI
-    note idem a mkmflib
+  - mkmflib : Creation of a GNUmakefile in each library module
 
-  - mkmfprog
-    Creation de GNUmakefile pour les modules ne contenant que des 
-    executables 
+  - mkmfPI : Creation of a GNUmakefile for PI and PIext module
+
+  - Top level makefile creation
 
 
-En pratique, il suffit de se mettre ds Mgr/, avec la variable DPCDEVREP
-definie, et taper :
-mkmf, qui fait les etapes ci-dessus
-(a faire a chaque fois que l'on rajoute des fichiers),
-cree un GNUmakefile ds chaque module (SysTools/GNUmakefile, ...
- et ../GNUmakefile )
+* mkmflib 
+  Creation of the GNUmakefile for a library module
+  The file exclude in the module directory may contain the 
+  list of source files (.cc .c) not to be compiled.
+  Usage: mkmflib ModuleName
+  
+* mkmfprog
+  Creation of the GNUmakefile for a module containing 
+  the main programs 
+  Usage: mkmfprog ProgModuleName
 
 
-Pour construire le soft, se mettre au niveau de dessus
-tapez :
-make libs  # Pour construire les librairies .a
-           # Equivalent de faire make ds chaque module
 
-make slb   # Construit la(les) librairie(s) partagee(s)
-
-make PI    # Construit les modules PI (actuellement PI, PIext)
-
-make slbpi # construit la shared-lib libPI.so 
-